
/**
*
* @Author: Mike Hostetler - mike@tm-web.com
* @Version: 0.1
* @Revision History:
* 
*/

//Configuration Details
const SERVER_URL = "http://openideascompany.com/xul/server.php";
//End Configuration

function getNews()
{
  req = new phpRequest();
  req.add('nbews','1');
  var response = req.execute();
  return response;		
}


function doLogin() {
	var username = document.getElementById('loginUser').value;
	var password = document.getElementById('loginPass').value;

	req = new phpRequest();
	req.add('username',username);
	req.add('password',password);

	var response = req.execute();
	alert(response);
}

//Start phpRequest Object
function phpRequest() {
	this.parms = new Array();
	this.parmsIndex = 0;
	this.execute = phpRequestExecute;
	this.add = phpRequestAdd;
	this.server = SERVER_URL;
}

function phpRequestAdd(name,value) {
	this.parms[this.parmsIndex] = new Pair(name,value);
	this.parmsIndex++;
}

function phpRequestExecute() {
	var targetURL = this.server;
	
	try {
		var httpRequest = new XMLHttpRequest();
	}catch (e){
		alert('Error creating the connection!');
		return;
	}
	
	try {
		var txt = "?1";
		for(var i in this.parms) {
			txt = txt+'&'+this.parms[i].name+'='+this.parms[i].value;
		}
		//Two options here, only uncomment one of these
		//GET REQUEST
		httpRequest.open("GET", targetURL+txt, false, null, null);	

		//POST REQUEST EXAMPLE
		/*
		httpRequest.open("POST", targetURL+txt, false, null, null);	
		httpRequest.setRequestHeader("Content-Type","application/x-www-form-urlencoded");
		*/
		httpRequest.send('');
	}catch (e){
		alert('An error has occured calling the external site: '+e);
		return false;
	} 

	switch(httpRequest.readyState) {
		case 1,2,3:
			alert('Bad Ready State: '+httpRequest.status);
			return false;
		break;
		case 4:
			if(httpRequest.status !=200) {
				alert('The server respond with a bad status code: '+httpRequest.status);
				return false;
			} else {
				var response = httpRequest.responseText;
			}
		break;
	}
	
	return response;
}

function Pair(name,value) {
	this.name = name;
	this.value = value;
}



function F1tb_Search(event, type)
{
	// Create a few variables
	var URL = "";
	var isEmpty = false;

	// Get a handle to our search terms box
	var searchTermsBox = document.getElementById("F1tb-SearchTerms");
    
	// Get the value in the search terms box, trimming whitespace as necessary
	var searchTerms = F1tb_TrimString(searchTermsBox.value);

	// If there are no search terms, than we set isEmpty to true
	// Otherwise, we convert the search terms to a safe URI version
	if(searchTerms.length == 0) { isEmpty = true; }
	else { searchTerms = F1tb_ConvertTermsToURI(searchTerms); }

	// Do something different for differing search types
	switch(type)
	{
	// Build up the URL for an image search
	case "image":
		if(isEmpty) { URL = "http://community.flock.com/"; }
		else		{ URL = "http://community.flock.com/search/node/" + searchTerms; }
		break;

        case "nisearch":
		if(isEmpty) { URL = "http://wiki.flock.com/"; }
		else        { URL = "http://wiki.flock.com/index.php?go=Go&search=" + searchTerms; }
		break;

	// Build up the URL for a web search
	case "web":
	default:
		if(isEmpty) { URL = "http://www.google.com/search?hl=en&lr=&q=site%3Aflock.com&btnG=Search"; }
		else        { URL = "http://www.google.com/search?hl=en&lr=&btnG=Search&q=site%3Aflock.com+" + searchTerms;  }
		break;
		
		
	
	}
	
	// Load the URL in the browser window using the F1tb_LoadURL function
	F1tb_LoadURL(URL);
}

function F1tb_TrimString(string)
{
	// Return empty if nothing was passed in
	if (!string) return "";
	
	// Efficiently replace any leading or trailing whitespace
	var value = string.replace(/^\s+/, '');
	value = string.replace(/\s+$/, '');
	
	// Replace any multiple whitespace characters with a single space
	value = value.replace(/\s+/g, ' ');
	
	// Return the altered string
	return value;
}

function F1tb_ConvertTermsToURI(terms)
{
	// Split up the search terms based on the space character
	var termArray = new Array();
	termArray = terms.split(" ");
	var result = "";

	// Loop through the search terms, building up the result string
	for(var i=0; i<termArray.length; i++)
	{
		if(i > 0) { result += "+"; }
		
		// Call the built-in function encodeURIComponent() to clean up
		// this search term (making it safe for use in a URL)
		result += encodeURIComponent(termArray[i]);
	}

	// Return the result
	return result;
}

function F1tb_LoadURL(URL)
{
	// Set the document's location to the incoming URL
	window._content.document.location = URL;
	
	// Make sure we get the focus
	window.content.focus();
}

function F1tb_Populate()
{
	// Get the menu element that we will be working with
	var menu = document.getElementById("F1tb-SearchTermsMenu");

	// Clean up whatever is currently in the menu
	for(var i=menu.childNodes.length - 1; i>=0; i--) {
		menu.removeChild(menu.childNodes.item(i));
	}

	// This string contains 5 "search terms", each separated by two pipes (||)
	var terms = "";

	// Create an array based on the terms in the string above
	var termArray = new Array();
	termArray = terms.split("||");

	// Load the search terms into our menu
	for(var i=0; i<termArray.length; i++)
	{
		// For each search term, create a menu item element
		var tempItem = null;
		tempItem = document.createElement("menuitem");

		// Set the menuitem element's various attributes:
		// The label will be the search term itself
		// The tooltip will be the text "Dynamic Item #", where # is the number of the item
		
		tempItem.setAttribute("label", termArray[i]);
		tempItem.setAttribute("tooltiptext", "Dynamic Item " + (i+1));

		// Add the item to our menu
		menu.appendChild(tempItem);
	}
}
function createMenuItem(aLabel) {
  const XUL_NS = "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul";
  var item = document.createElementNS(XUL_NS, "menuitem"); 
  item.setAttribute("label", aLabel);
  return item;
}


function doCMD(el) {
	v = el.getAttribute("id")
	if(v!="GBLTut-MainMenu-NI")
	{
	 F1tb_LoadURL(v);
   }
	
}

function GBGT_getweather(el)
{
   var thismen = document.getElementById("F1tb-MainMenu-FRXML");
   var lnews = getNews();
   var termArray = new Array();
   var turl = new Array();
   var ttitle = new Array();
  // var tempItem1 = null;
  // var tempItem2 = null;
  // var tempItem3 = null;
   
   termArray = lnews.split("||");
   while(thismen.hasChildNodes())
   {
     thismen.removeChild(thismen.firstChild);	
   } 
       
   for(var i=0; i<3; i++)
	{
	  base=termArray[i].split("^");
	  ttitle[i]=base[0];
	  turl[i]=base[1];
  	}  
	
	  var tempItem1 = createMenuItem(ttitle[0]);
          tempItem1.setAttribute("id",turl[0]);
          tempItem1.setAttribute("tooltiptext","Flock Radio RSS");
	  
	  var tempItem2 = createMenuItem(ttitle[1]);
	  tempItem2.setAttribute("id",turl[1]);
	  tempItem1.setAttribute("tooltiptext","Flock Radio RSS");
	  
	  var tempItem3 = createMenuItem(ttitle[2]);
	  tempItem3.setAttribute("id",turl[2]);
	  tempItem1.setAttribute("tooltiptext","Flock Radio RSS");
	  
	   //thismen.insetBefore(tempItem1,thismen.firstChild);
	   
           thismen.appendChild(tempItem1);
           thismen.appendChild(tempItem2);
           thismen.appendChild(tempItem3);
           doCMD(el);
 }